## libavif 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)

project("libargparse")

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
    #Only set compiler settings if we are not a sub-project
    set(WARN_FLAGS "-Wall -Wextra -Wpedantic -Wcast-qual -Wcast-align -Wshadow -Wformat=2 -Wlogical-op -Wmissing-declarations -Wmissing-include-dirs -Wredundant-decls -Wswitch-default -Wundef -Wunused-variable -Wdisabled-optimization -Wnoexcept -Woverloaded-virtual -Wctor-dtor-privacy -Wnon-virtual-dtor")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --std=c++14 ${WARN_FLAGS}") 
    #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize=leak -fsanitize=undefined") 
    set(FLEX_BISON_WARN_SUPPRESS_FLAGS "-Wno-switch-default -Wno-unused-parameter -Wno-missing-declarations")
endif()

set(LIB_INCLUDE_DIRS src)
file(GLOB_RECURSE LIB_SOURCES src/*.cpp)
file(GLOB_RECURSE LIB_HEADERS src/*.hpp src/*.tpp)

#Create the library
add_library(libargparse STATIC
             ${LIB_HEADERS}
             ${LIB_SOURCES})
set_target_properties(libargparse PROPERTIES PREFIX "") #Avoid extra 'lib' prefix
set_target_properties(libargparse PROPERTIES PUBLIC_HEADER "${LIB_HEADERS}")
target_include_directories(libargparse PUBLIC ${LIB_INCLUDE_DIRS})
install(TARGETS libargparse)

if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
    #Create the test executable
    add_executable(argparse_test argparse_test.cpp)
    target_link_libraries(argparse_test libargparse)
    add_test(NAME argparse_test COMMAND argparse_test)
    enable_testing()

    #Create the example executable
    add_executable(argparse_example argparse_example.cpp)
    target_link_libraries(argparse_example libargparse)
endif()

=== debian/changelog ===
libavif (1.3.0-1ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 20 Aug 2025 20:08:37 +0200

libavif (1.3.0-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/changelog: Merge NMU changelog history.

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Aug 2025 12:38:49 -0400

libavif (1.3.0-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 16 May 2025 10:37:47 -0400

libavif (1.2.1-1.2ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 26 May 2025 13:57:10 +0200

libavif (1.2.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix upstream bug reference for patch for CVE-2025-48175
  * Add another integer overflow check to makeRoom

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 25 May 2025 07:27:30 +0200

libavif (1.2.1-1.1ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable pandoc and rav1e on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 19 May 2025 07:54:30 +0200

libavif (1.2.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add integer overflow checks to makeRoom (CVE-2025-48174) (Closes:
    #1105885)
  * Add integer overflow check to makeRoom (CVE-2025-48174) (Closes: #1105885)
  * Fix format errors (CVE-2025-48174) (Closes: #1105885)
  * Declare *RowBytes as size_t in avifImageRGBToYUV() (CVE-2025-48175)
    (Closes: #1105883)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 17 May 2025 16:03:36 +0200

=== debian/control ===
Source: libavif
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.13),
 debhelper-compat (= 13),
 libaom-dev (>= 3~),
 libcjson-dev,
 libdav1d-dev,
# only enable when libgav1-dev exist, see rules file
 libgav1-dev [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el riscv64 loong64 x32],
 libgdk-pixbuf-2.0-dev,
 libjpeg-dev,
 libpng-dev,
# only enable when librav1e-dev exist, see rules file
 librav1e-dev [amd64 arm64 armel armhf mips64el mipsel ppc64el s390x powerpc ppc64 riscv64 loong64],
 libsharpyuv-dev,
 libsvtav1enc-dev,
 libyuv-dev,
# Disable doc build on arch with broken pandoc: kfreebsd-*, m68k, powerpc, sh4, x32, hppa, hurd-i386, loong64, sparc64
 pandoc [!i386 !kfreebsd-amd64 !kfreebsd-i386 !m68k !powerpc !sh4 !x32 !hppa !hurd-i386 !loong64 !sparc64] <!nodoc>,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/AOMediaCodec/libavif
Vcs-Git: https://salsa.debian.org/multimedia-team/libavif.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libavif
Description: Library for handling .avif files
 This library aims to be a friendly, portable C implementation of the AV1
 Image File Format as described in https://aomediacodec.github.io/av1-avif/.

Package: libavif-bin
Section: utils
Architecture: any
Depends:
 libavif16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (utilities)
 ${source:Extended-Description}
 .
 This package provides several utilities provided by the library:
  - avifdec
  - avifenc

Package: libavif-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
# Manually maintained binary build-dependency as recorded in .pc file
 libaom-dev (>= 3~),
 libdav1d-dev,
 librav1e-dev [amd64 arm64 armel armhf mips64el mipsel ppc64el s390x powerpc ppc64 riscv64 loong64],
 libsvtav1enc-dev,
 libyuv-dev,
 libavif16 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides the development files.

Package: libavif16
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides the shared library files.

Package: libavif-gdk-pixbuf
Architecture: any
Multi-Arch: same
Depends:
 libavif16 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libavif7-gdk-pixbuf,
 libavif8-gdk-pixbuf,
Replaces:
 libavif7-gdk-pixbuf,
 libavif8-gdk-pixbuf,
Description: ${source:Synopsis} (GDK pixbuf plugin)
 ${source:Extended-Description}
 .
 This package provides the GDK pixbuf plugin for the library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

include /usr/share/dpkg/architecture.mk

# only enable GAV1 on certain architectures
# sync with debian/control
LIBGAV1_FLAG := -DAVIF_CODEC_LIBGAV1=OFF

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf i386 mips64el mipsel ppc64el loong64 riscv64 x32))
  LIBGAV1_FLAG := -DAVIF_CODEC_LIBGAV1=SYSTEM
endif


# only enable RAV1E on certain architectures
# sync with debian/control
RAV1E_FLAG := -DAVIF_CODEC_RAV1E=OFF

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armel armhf mips64el mipsel ppc64el s390x powerpc ppc64 riscv64))
  RAV1E_FLAG := -DAVIF_CODEC_RAV1E=SYSTEM
endif


# flag for building doc (man page)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
  MAN_PAGES_FLAG := -DAVIF_BUILD_MAN_PAGES=ON
else
  MAN_PAGES_FLAG := -DAVIF_BUILD_MAN_PAGES=OFF
endif

# disable doc build on architecture with broken pandoc, see also d/control
ifneq (,$(filter $(DEB_HOST_ARCH), i386 kfreebsd-amd64 kfreebsd-i386 m68k powerpc sh4 x32 hppa hurd-i386 loong64 sparc64))
  MAN_PAGES_FLAG := -DAVIF_BUILD_MAN_PAGES=OFF
endif


%:
	dh $@

execute_before_dh_auto_configure:
	# Strip embedded libyuv source code, we prefer library from OS
	rm -rfv third_party/libyuv/
	# Copy the libargparse component to the extracted location
	cp -rv libargparse ext/libargparse/

# rpath: check https://bugs.debian.org/1003371
#        drop when debhelper-compat >= 14
override_dh_auto_configure:
	dh_auto_configure -- \
	    -DAVIF_LIBYUV=SYSTEM \
	    -DAVIF_BUILD_APPS=ON \
	    -DAVIF_CODEC_DAV1D=SYSTEM \
	    -DAVIF_CODEC_AOM=SYSTEM \
	    -DAVIF_CODEC_SVT=SYSTEM \
	    $(LIBGAV1_FLAG) \
	    $(RAV1E_FLAG) \
	    -DAVIF_BUILD_GDK_PIXBUF=ON \
	    -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	    $(MAN_PAGES_FLAG) \
	    $(NULL)

# Manual man page installation for nodoc profile/option
# to avoid hard build-dependency on pandoc
execute_after_dh_install:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifeq ($(MAN_PAGES_FLAG),-DAVIF_BUILD_MAN_PAGES=ON)
	# Install fresh built man pages to libavif-bin package
	install -d $(CURDIR)/debian/libavif-bin/usr/share/man/man1/
	install -m644 debian/tmp/usr/share/man/man1/avifdec.1 debian/libavif-bin/usr/share/man/man1/
	install -m644 debian/tmp/usr/share/man/man1/avifenc.1 debian/libavif-bin/usr/share/man/man1/
	rm -f debian/tmp/usr/share/man/man1/avifdec.1
	rm -f debian/tmp/usr/share/man/man1/avifenc.1
else
	# Fallback when man pages needed but unable to build, use prebuilt man pages (may be outdated)
	install -d $(CURDIR)/debian/libavif-bin/usr/share/man/man1/
	install -m644 debian/avifdec.1 debian/libavif-bin/usr/share/man/man1/
	install -m644 debian/avifenc.1 debian/libavif-bin/usr/share/man/man1/
endif
endif

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libavif-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/" \
  https://github.com/AOMediaCodec/libavif/tags .*/v?(\d\S+)\.tar\.gz debian uupdate
opts="component=libargparse,mode=git,pgpmode=none" \
 https://github.com/kmurray/libargparse HEAD ignore
